/*
 * ace.h
 *
 *  Created on:
 *      Author: Eduardo Sepulveda
 */

#ifndef ADC_H_
#define ADC_H_

#include "PickMouse_types.h"
#include "stdint.h"

/* In DMA mode, BURST mode and ADC_INTERRUPT flag need to be set. */
/* In BURST mode, ADC_INTERRUPT need to be set. */

#define ADC_INTERRUPT_FLAG	0	/* 1 is interrupt driven, 0 is polling */
#define BURST_MODE			1   /* Burst mode works in interrupt driven mode only. */
#define ADC_DEBUG			1

#define ADC_OFFSET          0x10
#define ADC_INDEX           4

#define ADC_DONE            0x80000000
#define ADC_OVERRUN         0x40000000
#define ADC_ADINT           0x00010000

#define ADC_NUM				8			/* for LPCxxxx */
#define ADC_CLK				1000000		/* set to 1Mhz */
//#define ADC_CLK			500000		/* set to 500hz ?*/

extern void ADC_IRQHandler( void );
extern void ADCInit( uint32_t ADC_Clk );
extern uint32_t ADCRead( uint8_t channelNum,bool filter );
#endif /* ADC_H_ */
