/*
===============================================================================
 Name        : gpio.c
 Author      : Eduardo Rafael Sepulveda de Ugarte
 Version     : 1.0
 Description : Management of data received from acelerometer MMA7361 for PICKMOUSE Project.
 	 	 	   movement recognition and filters.
 ===============================================================================
 */

#include <stdlib.h>
#include <stdio.h>
#include "FreeRTOS.h"
#include "basic_io.h"

#include "acel.h"
#include "adc.h"
//#include "basic_io.h"

//#include "acelMMA7361.h"

t_move movement = STOP;

uint32_t chan0_repose=0;
uint32_t chan1_repose=0;
uint32_t chan2_repose=0;

uint32_t chan0_value1=0;
uint32_t chan1_value1=0;
uint32_t chan2_value1=0;

uint32_t chan0_value2=0;
uint32_t chan1_value2=0;
uint32_t chan2_value2=0;

uint32_t chan0_value3=0;
uint32_t chan1_value3=0;
uint32_t chan2_value3=0;

uint32_t chan0_value_dif1=0;
uint32_t chan1_value_dif1=0;
uint32_t chan2_value_dif1=0;

uint32_t chan0_value_dif2=0;
uint32_t chan1_value_dif2=0;
uint32_t chan2_value_dif2=0;

uint32_t chan0_value_dif3=0;
uint32_t chan1_value_dif3=0;
uint32_t chan2_value_dif3=0;

uint32_t chan0_value_dif4=0;
uint32_t chan1_value_dif4=0;
uint32_t chan2_value_dif4=0;

uint32_t chan0_start = 0;

bool discartX = false;
bool discartY = false;
bool discartZ = false;

bool StartX = false;
bool StartY = false;
bool StartZ = false;

uint32_t InitValue_X =0;
uint32_t InitValue_Y =0;
uint32_t InitValue_Z =0;

uint32_t EndValue_X =0;
uint32_t EndValue_Y =0;
uint32_t EndValue_Z =0;

uint32_t chan0_MAX_value_dif1=0;
uint32_t chan1_MAX_value_dif1=0;
uint32_t chan2_MAX_value_dif1=0;

uint32_t chan0_MAX_value_dif2=0;
uint32_t chan1_MAX_value_dif2=0;
uint32_t chan2_MAX_value_dif2=0;

uint32_t chan0_MIN_value_dif1=999999;
uint32_t chan1_MIN_value_dif1=999999;
uint32_t chan2_MIN_value_dif1=999999;

uint32_t chan0_MIN_value_dif2=999999;
uint32_t chan1_MIN_value_dif2=999999;
uint32_t chan2_MIN_value_dif2=999999;


void ADC_ResetDiscarts()
{
	discartX=false;
	discartY=false;
	discartZ=false;
}

void ADC_MoveValues()
{
	chan0_value1=chan0_value2;
	chan0_value2=chan0_value3;

	chan1_value1=chan1_value2;
	chan1_value2=chan1_value3;

	chan2_value1=chan2_value2;
	chan2_value2=chan2_value3;
}

void ADC_DiscartNoiseData(bool disX,bool disY,bool disZ)
{
	if (disX)
		chan0_value2 = chan0_value1;
		//chan0_value2 = (chan0_value1+chan0_value3)/2;

	if (disY)
		chan0_value2 = chan1_value1;
		//chan1_value2 = (chan1_value1+chan1_value3)/2;

//	if (disZ)
//		chan2_value2 = (chan2_value1+chan2_value3)/2;
}

int ADC_LookFor_Start_Stop_Y()
{	//TODO: Avoid magic numbers!!!!!

	if ( (chan1_value_dif1 == 0)||(chan1_value_dif2 == 0) )
			return 0;

	if (chan1_value2 > (chan1_repose + 800) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return 4;
	}
	else
	if (chan1_value2 > (chan1_repose + 600) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return 3;
	}
	else
	if (chan1_value2 > (chan1_repose + 400) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return 2;
	}
	else
	if (chan1_value2 > (chan1_repose + 200) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return 1;
	}
	else
	if (chan1_value2 < (chan1_repose - 800) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return -4;
	}
	else
	if (chan1_value2 < (chan1_repose - 600) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return -3;
	}
	else
	if (chan1_value2 < (chan1_repose - 400) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return -2;
	}
	else
	if (chan1_value2 < (chan1_repose - 200) )
	{
		//vPrintStringAndNumber( "\n Y->",chan1_value2);
//		printf( "\nY->%i - %i - %i ,%i,%i ",chan1_value1,chan1_value2,chan1_value3,chan1_value_dif1,chan1_value_dif2);
		return -1;
	}
	else
	{
		//vPrintString( "\n Y STOP");
		return 0;
	}
}

int ADC_LookFor_Start_Stop_X()
{
	if ( (chan0_value_dif1 == 0)||(chan0_value_dif2 == 0) )
		return 0;

	if (chan0_value2 > (chan0_repose + 800) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
		//printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return 4;
	}
	else
	if (chan0_value2 > (chan0_repose + 600) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
		//printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return 3;
	}
	else
	if (chan0_value2 > (chan0_repose + 400) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return 2;
	}
	else
	if (chan0_value2 > (chan0_repose + 200) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return 1;
	}
	else	//DOWN-------------------------------------------------------------
	if (chan0_value2 < (chan0_repose - 800) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return -4;
	}
	else
	if (chan0_value2 < (chan0_repose - 600) )
	{
		//vPrintStringAndNumber( "\n X->",chan0_value2);
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return -3;
	}
	else
	if (chan0_value2 < (chan0_repose - 400) )
	{
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return -2;
	}
	else
	if (chan0_value2 < (chan0_repose - 200) )
	{
//		printf( "\nX->%i - %i - %i ,%i,%i ",chan0_value1,chan0_value2,chan0_value3,chan0_value_dif1,chan0_value_dif2);
		return -1;
	}
	else
	{
		//vPrintString( "\n X STOP ");
		return 0;
	}
}

void ADC_GetReposeValues(int chanx, int chany,int chanz)
{
	int cont=0;

	printf( "\n[ADC_GetReposeValues] Start.");

	for( cont=0; cont<12; cont++ )
	{
		ADC_GetAcel(chanx, chany, chanz, false, true);

		if (cont > 1)
		{
			ADC_CalculateDiffs();

			if (ADC_ExtreamsValuesFilter())
				ADC_CalculateDiffs();

			//Calculate distances
			ADC_CalculateDiffs();

			//Look for noise
			ADC_LookForNoise(&discartX,&discartY,&discartZ);

			//Discard noise data
			ADC_DiscartNoiseData(discartX,discartY,discartZ);

			if (discartX || discartY || discartZ)
			{
				//ReCalculate distances
				ADC_CalculateDiffs();
			}

			chan0_repose += chan0_value2;
			chan1_repose += chan1_value2;
			//chan2_repose += chan2_value2;
		}
		//vPrintString( "\n%u;%u;%u",chan0_value2,chan1_value2,chan2_value2);
		//ADC_PrintDiffs();
		printf("\nx=%u y=%u",chan0_value2,chan1_value2);

		//Move Values
		ADC_MoveValues();
	}

	chan0_repose = chan0_repose/10;
	chan1_repose = chan1_repose/10;
	//chan2_repose = chan2_repose/10;

	printf( "\n[ADC_GetReposeValues] Repose Values: %u;%u",chan0_repose,chan1_repose);

	discartX=false;
	discartY=false;
	//discartZ=false;

	ADC_ResetDiffs();
}

bool ADC_ExtreamsValuesFilter()
{
	bool problem = false;

	if (chan0_value_dif2 == 0)
	{
		chan0_value2 = chan0_value1;
		chan0_value3 = chan0_value1;
		problem = true;
	}

	if ( (chan0_value_dif2 > 1500) && (chan0_value3 > 4000) )
	{
		chan0_value3 = chan0_value1 ;
		problem = true;
	}

	if ( (chan0_value_dif2 > 1500) && (chan0_value3 < 600) )
	{
		chan0_value3 = chan0_value1;
		problem = true;
	}
//-----------------------------------------------------

	if (chan1_value_dif2 == 0)
	{
		chan1_value2 = chan1_value1;
		chan1_value3 = chan1_value1;
		problem = true;
	}

	if ( (chan1_value_dif2 > 1500) && (chan1_value3 > 4000) )
	{
		chan1_value3 = chan1_value2;
		problem = true;
	}

	if ( (chan1_value_dif2 > 1500) && (chan1_value3 < 600) )
	{
		chan1_value3 = chan1_value2;
		problem = true;
	}

	return problem;
}


void ADC_LookForNoise(bool* disX,bool* disY,bool* disZ)
{
	if ( (chan0_value_dif1 > 50) && (chan0_value_dif2 > 50))
	{
		//printf( ";CHAN_X");
		//discartX = true;
		*disX=true;
		//chan0_value_dif2 = chan0_value_dif1;	//_Discard noise
	}

	if ( (chan1_value_dif1 > 50) && (chan1_value_dif2 > 50))
	{
		//printf( ";CHAN_Y");
		//discartY = true;
		*disY=true;
		//chan1_value_dif2 = chan1_value_dif1;	//_Discard noise
	}
}

void ADC_MaxMinDiffs()
{
	if (!discartX)
	{
		if (chan0_value_dif1 > chan0_MAX_value_dif1 )
			chan0_MAX_value_dif1= chan0_value_dif1;
		if (chan0_value_dif2 > chan0_MAX_value_dif2 )
			chan0_MAX_value_dif2=chan0_value_dif2 ;

		if (chan0_value_dif1 < chan0_MIN_value_dif1)
			chan0_MIN_value_dif1=chan0_value_dif1;
		if (chan0_value_dif2 < chan0_MIN_value_dif2 )
			chan0_MIN_value_dif2=chan0_value_dif2;
	}
	if (!discartY)
	{
		if (chan1_value_dif1 > chan1_MAX_value_dif1 )
			chan1_MAX_value_dif1=chan1_value_dif1;
		if (chan1_value_dif2 > chan1_MAX_value_dif2 )
			chan1_MAX_value_dif2=chan1_value_dif2;

		if (chan1_value_dif1 < chan1_MIN_value_dif1 )
			chan1_MIN_value_dif1=chan1_value_dif1;
		if (chan1_value_dif2 < chan1_MIN_value_dif2 )
			chan1_MIN_value_dif2=chan1_value_dif2;
	}
	if (!discartZ)
	{
		if (chan2_value_dif1 > chan2_MAX_value_dif1 )
			chan2_MAX_value_dif1=chan2_value_dif1;
		if (chan2_value_dif2 > chan2_MAX_value_dif2 )
			chan2_MAX_value_dif2=chan2_value_dif2;

		if (chan2_value_dif1 < chan2_MIN_value_dif1 )
			chan2_MIN_value_dif1=chan2_value_dif1;
		if (chan2_value_dif2 < chan2_MIN_value_dif2 )
			chan2_MIN_value_dif2=chan2_value_dif2;
	}
}

void ADC_PrintDiffs()
{
//Print differences
	printf( "\t;X: d1=%u d2=%u d3=%u d4=%u",chan0_value_dif1,chan0_value_dif2,chan0_value_dif3,chan0_value_dif4);
	printf( ";Y: d1=%u d2=%u d3=%u d4=%u",chan1_value_dif1,chan1_value_dif2,chan1_value_dif3,chan1_value_dif4);
//printf( "\t;Z: d1=%u d2=%u d3=%u d4=%u",chan2_value_dif1,chan2_value_dif2,chan2_value_dif3,chan2_value_dif4);
}

void ADC_PrintMaxMinDiffs()
{
//Print MAX MINS
	printf( "\n dif_1_max_X=%u dif_1_min_X=%u   --   dif_2_max_X=%u dif_2_min_X=%u",chan0_MAX_value_dif1,chan0_MIN_value_dif1,chan0_MAX_value_dif2,chan0_MIN_value_dif2);
	printf( "\n\n dif_1_max_Y=%u dif_1_min_Y=%u   --   dif_2_max_Y=%u dif_2_min_Y=%u",chan1_MAX_value_dif1,chan1_MIN_value_dif1,chan1_MAX_value_dif2,chan1_MIN_value_dif2);
	printf( "\n\n dif_1_max_Z=%u dif_1_min_Z=%u   --   dif_2_max_Z=%u dif_2_min_Z=%u",chan2_MAX_value_dif1,chan2_MIN_value_dif1,chan2_MAX_value_dif2,chan2_MIN_value_dif2);
}

void ADC_ResetDiffs()
{
	chan0_value_dif1 = 0;
	chan1_value_dif1 = 0;
	chan2_value_dif1 = 0;

	chan0_value_dif2 = 0;
	chan1_value_dif2 = 0;
	chan2_value_dif2 = 0;

	chan0_value_dif3 = 0;
	chan1_value_dif3 = 0;
	chan2_value_dif3 = 0;

	chan0_value_dif4 = 0;
	chan1_value_dif4 = 0;
	chan2_value_dif4 = 0;
}

void ADC_ResetVals()
{
	chan0_value1 = 0;
	chan0_value2 = 0;
	chan0_value3 = 0;

	chan1_value1 = 0;
	chan1_value2 = 0;
	chan1_value3 = 0;

	chan2_value1 = 0;
	chan2_value2 = 0;
	chan2_value3 = 0;
}

void ADC_CalculateDiffs()
{
	chan0_value_dif1 = abs( chan0_value1 - chan0_value2);
	chan1_value_dif1 = abs( chan1_value1 - chan1_value2);
//	chan2_value_dif1 = abs( chan2_value1 - chan2_value2);

	chan0_value_dif2 = abs( chan0_value3 - chan0_value2);
	chan1_value_dif2 = abs( chan1_value3 - chan1_value2);
//	chan2_value_dif2 = abs( chan2_value3 - chan2_value2);

	chan0_value_dif3 = abs( chan0_value_dif1 - chan0_value_dif2);
	chan1_value_dif3 = abs( chan1_value_dif1 - chan1_value_dif2);
//	chan2_value_dif3 = abs( chan2_value_dif1 - chan2_value_dif2);

	chan0_value_dif4 = abs( chan0_value1 - chan0_value3);
	chan1_value_dif4 = abs( chan1_value1 - chan1_value3);
//	chan2_value_dif4 = abs( chan2_value1 - chan2_value3);

}

void ADC_GetAcel(int chanx, int chany,int chanz, bool lib, bool filter)
{
	if (!lib)
	{	// NOT using library acelMMA7361_h
	chan0_value3 = ADCRead(chanx,filter);
	chan1_value3 = ADCRead(chany,filter);
	chan2_value3 = ADCRead(chanz,filter);
	}
}
